#include <time.h>
#include <stdio.h>
#include <iostream>

using namespace std;

const char* const ifo = "H1";
const char* const ifonum = "1";
const char* const rm = "0";
const char* const excdcu = "26";
const char* const tpdcu = "28";


const char* const mirrors[] =
{
"ITMX",
"ITMY",
"RM",
"BS",
"MMT3",
"MC1",
"MC2",
"MC3",
"SM1",
"MMT1",
"MMT2",
"ETMX",
"ETMY"
};

const char* const magnets[] =
{
"UL",
"LL",
"UR",
"LR",
"SD"
};

int exc = 550;
int tp = 790;

int main (int argc, char** argv)
{
   // LVEA sensor excitations
   for (int i = 0; i < 11; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_SENSOR_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   // LVEA coil excitations
   for (int i = 0; i < 11; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_COIL_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   // ETMX sensor/coil excitations
   for (int i = 11; i < 12; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_SENSOR_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   for (int i = 11; i < 12; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_COIL_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   // ETMY sensor/coil excitations
   for (int i = 12; i < 13; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_SENSOR_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   for (int i = 12; i < 13; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_COIL_" <<
	    magnets[j] << "_EXC\t" << exc++ << "\t" << excdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
   
   // testpoints
   for (int i = 0; i < 13; ++i) {
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_SENSOR_FILTER_" <<
	    magnets[j] << "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
       cout << ifo << "\tSUS\t" << mirrors[i] << "_L1_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
       cout << ifo << "\tSUS\t" << mirrors[i] << "_P1_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
       cout << ifo << "\tSUS\t" << mirrors[i] << "_Y1_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
       cout << ifo << "\tSUS\t" << mirrors[i] << "_L2_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
       cout << ifo << "\tSUS\t" << mirrors[i] << "_P2_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
       cout << ifo << "\tSUS\t" << mirrors[i] << "_Y2_TO" <<
           "\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      for (int j = 0; j < 5; ++j) {
         cout << ifo << "\tSUS\t" << mirrors[i] << "_COIL_" <<
	    magnets[j] << "_TO\t" << tp++ << "\t" << tpdcu << "\t" << 
	    ifonum << "\t" << rm << "\t4\t2048" << endl;
      }
   }
}
